unit uFormularioBase;

{$mode delphi}
{$DEFINE DEBUG}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Dialogs, StdCtrls, EditBtn,
  Graphics, xmatdefs, maskedit, contnrs, ExtCtrls,

  ucosa, ufechas, usalasdejuego;

type

  { TFormularioBase }

  TFormVersion=(NEW, OLD);

  TFormularioBase = class(TForm)
    procedure FormCreate(Sender: TObject);

  protected

    ParentForm: TFormularioBase;
    OnEnterVal: string;

    guardado: boolean;

  public
    { public declarations }

    //Es una lista de todos los dataCell involucrados en la edicion,
    //hace el vinculo entre los controles y los datacell mediante la propiedad
    //tag del control y i en indice en dr_local
    LocalDataRow: TDataRowOfCosa;
    LocalDataColumnList:TDataColumnListOfCosa;
    LocalDataTable:TDataTableOfCosa;

    {dfusco@20150422
     El SIUD (SELECT, INSERT, UPDATE, DELETE) de la ventana. }
    SIUD:TSIUD;

    {dfusco@20150424
     Para saber si la ventana es NUEVA (trabaja con REGISTRO DE BASE DE DATOS)
     o VIEJA (trabaja con OBJETO). }
    FormVersion:TFormVersion;

    DataSet: TDataStore;
    hayCambios: boolean;

    constructor Create(TheOwner: TComponent); override; overload;
    constructor Create(TheOwner: TComponent; ADataSet: TDataStore; xTitle: string); overload;

    //function PrepareInsert(Into, ColumnName: string; RowId: integer;
    //  Value: string; isItemOfList: boolean = True): TDataStore;
    //function PrepareUpdate(From, ColumnName: string; RowId: integer;
    //  Value: string; lst: boolean): TDataStore;
    //
    ////El delete solo se perimite para items de listas.
    //function PrepareDelete(From, ColumnName: string; RowId: integer;
    //  Value: string; lst: boolean = True): TDataStore;

    //function Query(Select: string; From: string; var DataSet: TDataStore): boolean;
    //  overload;
    //function Query(Select: string; From: string; ColumnName: string;
    //  ColumnValue: string; var DataSet: TDataStore): boolean; overload;
    //function Query(Select: string; From: string; RowId: integer;
    //  var DataSet: TDataStore): boolean;

    function Save(): integer; virtual; abstract;

    function HuboCambios(): boolean;

    function UpdateDataCell(Sender: TObject):boolean;

  end;

  FormBaseClass = class of TFormularioBase;


var
  FormularioBase: TFormularioBase;


implementation

{$R *.lfm}

uses
  uBaseFormularios, uBaseEditores,
  {$IFDEF MISION_IMPOSIBLE}
  uFormularioAutomatico,
  {$ENDIF}
  uBaseEditoresFichas, uBaseEditoresCosasConNombre;

{ TFormularioBase }

//constructor TFormularioBase.Create(AOwner: Tcomponent;
//  xParentForm: TFormularioBase; xTitle: string);
//begin
//  inherited Create(AOwner);
//  self.ParentForm := xParentForm;
//  self.Caption := xTitle;
//  self.hayCambios := False;
//end;

procedure TFormularioBase.FormCreate(Sender: TObject);
begin
  self.guardado:=false;
end;

constructor TFormularioBase.Create(TheOwner: TComponent);
var
  DataRowList: TList;
begin

  inherited Create(TheOwner);

  self.LocalDataColumnList:=TDataColumnListOfCosa.Create();
  self.LocalDataRow:=TDataRowOfCosa.Create;
  self.LocalDataRow._RowId:=1001;

  DataRowList:=TList.Create();
  DataRowList.Add(self.LocalDataRow);

  self.LocalDataTable:=TDataTableOfCosa.Create('Tabla Local', self.LocalDataColumnList, DataRowList);

end;

constructor TFormularioBase.Create(TheOwner: TComponent; ADataSet: TDataStore;
  xTitle: string);
begin
  self.Create(TheOwner);

  self.DataSet:=ADataSet;
  self.Caption:=xTitle;
end;


function TFormularioBase.HuboCambios: boolean;
begin

end;

function TFormularioBase.UpdateDataCell(Sender: TObject): boolean;
var
  DataTable:TDataTableOfCosa;
  DataColumn:TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  sval: string;
  ErrorMessage: string;
  isValid:boolean;
  validation: TValidation;
  i: Integer;
  ValidationList: TListValidation;

  bDataColumnName: String;
  bDataColumn: TDataColumnOfCosa;
  bsval: string;
  a: PtrInt;
  split: TStringList;

begin

  isValid:=true;

  a:=TWinControl(Sender).Tag;

  DataColumn:=self.LocalDataColumnList.Items[TWinControl(Sender).Tag];
  DataCell:=self.LocalDataRow.DataCellList[TWinControl(Sender).Tag];
  DataTable:=DataColumn.DataColumnListOwner.DataTableOwner;

  if      Sender is TCustomEdit    then sval:=TCustomEdit(Sender).Text
  else if Sender is TCheckBox      then sval:=BoolToStr(TCheckBox(Sender).Checked)
  else if Sender is TRadioGroup    then sval:=IntToStr(TRadioGroup(Sender).ItemIndex)
  else if Sender is TRadioButton   then sval:=BoolToStr(TRadioButton(Sender).Checked)
  else if Sender is TComboBox      then sval:=TComboBox(Sender).Text;

  if DataCell.sval <> sval then
  begin

    if Sender is TCustomEdit then
    begin
      if DataColumn.DataType.Validate(sval, ErrorMessage) then
      begin
        if Assigned(DataColumn.DataColumnListOwner.ValidationList) and
          (DataColumn.DataColumnListOwner.ValidationList.Count>0) then
        begin
          ValidationList:=DataColumn.DataColumnListOwner.ValidationList.GetValidationToDoOverField(Copy(DataColumn.ColumnName, Pos('_',DataColumn.ColumnName)+1, Length(DataColumn.ColumnName)));
          if ValidationList.Count>0 then
            for i:=0 to ValidationList.Count-1 do
            begin
              validation:=ValidationList.Items[i];

              bDataColumnName:=Copy(DataTable.TableName, 4, Length(DataTable.TableName))+'_'+validation.B;
              bDataColumn:=self.LocalDataTable.GetDataColumnByName(bDataColumnName);
              if Assigned(BDataColumn) then
              begin

                {$IFDEF DEBUG}
                if DataColumn.DataType.ClassName<>bDataColumn.DataType.ClassName then
                  raise Exception.Create('TFormularioBase.UpdateDataCell: Para poder comparar las columnas ' + DataColumn.ColumnName + ' y ' + bDataColumnName + ', tienen que ser del mismo tipo.');
                {$ENDIF}

                self.LocalDataTable.ReadDataCellTextValue(bDataColumnName, bsval);

              end
              else
                bsval:=validation.B;

              isValid:=validation.Validate(DataColumn.DataType, sval, bsval);

              if not isValid then
              begin
                ErrorMessage:=validation.ErrorMessage;
                break;
              end;
            end;
        end;
      end
      else
      begin
        isValid:=false;
      end;
    end;

    if isValid then
    begin

      sval:=DataColumn.DataType.Format(sval);

      DataCell.sval:=sval;
      TEdit(Sender).Font.Color:=clBlack;
    end
    else
    begin
      MessageDlg('Error!', ErrorMessage, TMsgDlgType.mtError, [mbOK], 0);
      TEdit(Sender).Font.Color:=clRed;
      TEdit(Sender).SetFocus();
    end;

  end;

  Result:=isValid;

end;

//function TFormularioBase.PrepareInsert(Into, ColumnName: string;
//  RowId: integer; Value: string; isItemOfList: boolean): TDataStore;
//var
//  ds: TDataStore;
//  dr1, dr2: TDataRowOfCosa;
//  dt: TDataTableOfCosa;
//  dt_TList: TDataTableOfListOfCosa;
//
//  sval: string;
//  IdParent: string;
//  split: TStringList;
//  n: integer;
//  nsval: string;
//
//begin
//  ds := TDataStore.Create();
//  Query('*', Into, RowId, ds);
//  dt := ds.DataTableList[0];
//  dt.Visible := False;
//  Query('*', Value, 'AAA', '999', ds);
//  ds.DataTableList[1].Visible := True;
//  dr1 := ds.DataTableList[1].GetDataRowWithDefaulValues();
//  dr1.SIUD := TSIUD.TINSERT;
//  ds.DataTableList[1].AddDataRow(dr1);
//  if isItemOfList then
//  begin
//    ds.ReadDataCellTextValue(Into, RowId, 'n', nsval);
//    n := StrToInt(nsval);
//    ds.WriteDataCellTextValue(Into, RowId, 'n', IntToStr(n + 1));
//
//    Query('*', 'dt_TList', 'AAA', '999', ds);
//    dt_TList := TDataTableOfListOfCosa(ds.DataTableList[2]);
//    dt_TList.Visible := False;
//    dr2 := TDataRowOfCosa.Create;
//    dt_TList.AddDataRow(dr2);
//    dr2.SIUD := TSIUD.TINSERT;
//
//    ds.ReadDataCellTextValue(Into, RowId, ColumnName, sval);
//    if sval = '' then
//    begin
//      IdParent := IntToStr(dt_TList.GetNextIdParent());
//      ds.WriteDataCellTextValue(Into, RowId, ColumnName,
//        dt_TList.TableName + '.IdParent.' + IdParent);
//    end
//    else
//    begin
//      split := TStringList.Create;
//      try
//        ExtractStrings(['.'], [], PChar(sval), split);
//        IdParent := split[2];
//      finally
//        split.Free;
//      end;
//    end;
//
//    dr2.AddDataCell(TDataCellOfCosa.Create(IdParent));
//    dr2.AddDataCell(TDataCellOfCosa.Create(Value + '.' + IntToStr(dr1._RowId)));
//
//  end
//  else
//  begin
//    ds.WriteDataCellTextValue(Into, RowId, ColumnName, Value + '.' + IntToStr(dr1._RowId));
//  end;
//  Result := ds;
//end;
//
//function TFormularioBase.PrepareUpdate(From, ColumnName: string;
//  RowId: integer; Value: string; lst: boolean): TDataStore;
//var
//  ds: TDataStore;
//  dr1, dr2: TDataRowOfCosa;
//  dt: TDataTableOfCosa;
//
//  sval: string;
//  split: TStringList;
//  DataTableChildName: string;
//  DataRowChildId: integer;
//  lst_sval: string;
//  DataTableListName: string;
//  DataColumnName: string;
//  IdParent: string;
//  aDataTableItemName: string;
//  aDataRowItemId: integer;
//  j: integer;
//  ADataRow: TDataRowOfCosa;
//  ADataCell: TDataCellOfCosa;
//
//begin
//  ds := TDataStore.Create();
//  split := TStringList.Create;
//  try
//    ExtractStrings(['.'], [], PChar(Value), split);
//    DataTableChildName := split[0];
//    DataRowChildId := StrToInt(split[1]);
//  finally
//    split.Free;
//  end;
//
//  Query('*', DataTableChildName, DataRowChildId, ds);
//  ds.DataTableList[0].Visible := True;
//  if lst then
//  begin
//    //Como es una lista busco los items
//    ds.ReadDataCellTextValue(DataTableChildName, DataRowChildId, 'lst', lst_sval);
//
//    if (lst_sval <> '') then
//    begin
//      split := TStringList.Create;
//      try
//        ExtractStrings(['.'], [], PChar(lst_sval), split);
//        DataTableListName := split[0];
//        DataColumnName := split[1];
//        IdParent := split[2];
//      finally
//        split.Free;
//      end;
//      Query('*', DataTableListName, DataColumnName, IdParent, ds);
//      dt := ds.DataTableList[1];
//
//      for j := 0 to dt.DataRowListCount - 1 do
//      begin
//        ADataRow := dt.DataRowList[j];
//        if ADataRow.SIUD <> TSIUD.TDELETE then
//        begin
//          ADataCell := aDataRow.DataCellList[1];
//          split := TStringList.Create;
//          try
//            ExtractStrings(['.'], [], PChar(aDataCell.sval), split);
//            aDataTableItemName := split[0];
//            aDataRowItemId := StrToInt(split[1]);
//          finally
//            split.Free;
//          end;
//          Query('*', aDataTableItemName, aDataRowItemId, ds);
//          ds.GetDataTableByName(aDataTableItemName).Visible := False;
//        end;
//      end;
//    end;
//  end;
//
//  ds.DataTableList[0].DataRowList[0].SIUD := TSIUD.TUPDATE;
//
//  Result := ds;
//end;
//
//function TFormularioBase.PrepareDelete(From, ColumnName: string;
//  RowId: integer; Value: string; lst: boolean): TDataStore;
//var
//  ds, dsAux: TDataStore;
//  dtChildName: string;
//  drChildId: integer;
//
//  n: integer;
//  split: TStringList;
//
//  lst_sval: string;
//  IdParent: string;
//  nsval: string;
//
//begin
//  ds := TDataStore.Create();
//  Query('*', From, RowId, ds);
//  split := TStringList.Create;
//  try
//    ExtractStrings(['.'], [], PChar(Value), split);
//    dtChildName := split[0];
//    drChildId := StrToInt(split[1]);
//  finally
//    split.Free;
//  end;
//
//  Query('*', dtChildName, drChildId, ds);
//  ds.DataTableList[1].DataRowList[0].SIUD := TSIUD.TDELETE;
//  if lst then
//  begin
//    ds.ReadDataCellTextValue(From, RowId, 'n', nsval);
//    n := StrToInt(nsval);
//    ds.WriteDataCellTextValue(From, RowId, 'n', IntToStr(n - 1));
//
//    ds.ReadDataCellTextValue(From, RowId, 'lst', lst_sval);
//    split := TStringList.Create;
//    try
//      ExtractStrings(['.'], [], PChar(lst_sval), split);
//      IdParent := (split[2]);
//    finally
//      split.Free;
//    end;
//
//    dsAux := TDataStore.Create();
//    Query('*', 'dt_TList', 'IdParent', IdParent, ds);
//    ds.DeleteDataRows('dt_TList', 'IdChild', Value);
//
//
//    dsAux.Free;
//  end;
//
//  Result := ds;
//end;

//function TFormularioBase.Query(Select: string; From: string;
//  var DataSet: TDataStore): boolean;
//begin
//  Result := self.Query(Select, From, '', '', DataSet);
//end;
//
//function TFormularioBase.Query(Select: string; From: string;
//  ColumnName: string; ColumnValue: string; var DataSet: TDataStore): boolean;
//begin
//
//  if (self.DataSet.Query(Select, From, ColumnName, ColumnValue, DataSet) = False) then
//  begin
//    if (self.ParentForm <> nil) then
//      Result := self.ParentForm.Query(Select, From, ColumnName, ColumnValue, DataSet)
//    else
//      Result := DATA_STORE.Query(Select, From, ColumnName, ColumnValue, DataSet);
//  end
//  else
//    Result := True;
//end;
//
//function TFormularioBase.Query(Select: string; From: string;
//  RowId: integer; var DataSet: TDataStore): boolean;
//begin
//
//  if (self.DataSet.Query(Select, From, RowId, DataSet) = False) then
//  begin
//    if (self.ParentForm <> nil) then
//      Result := self.ParentForm.Query(Select, From, RowId, DataSet)
//    else
//      Result := DATA_STORE.Query(Select, From, RowId, DataSet);
//  end
//  else
//    Result := True;
//end;




end.
