unit uparametros;

{$mode delphi}

interface

uses
  Classes, SysUtils,
  xMatDefs,
  upreprocesador;


{
El parámetro tiene Nombre y un valor representado por un string
que es evaluado sobre una variable para la ejecución de la aplicación.
La idea es que la Sala de Juego se guarde con los parámetros SIN EVALUAR
de de forma que siempre sea posible incluir en los parámetros formulas
y marcro variables que se vean en el editor y que terminen siendo evaluadas
antes de Optimizar/Simular (al cargar la sala y activar el escenario).
Esto permitirá la definición de CASOS (definiendo Juegos de MarcroVariables).
}

type

  TParametro = class
    nombre: string;
    str_val: string;
    pvar: pointer;

    constructor Create( xNombre: string; var xvar; xStr_val: string );
    // retorna true si logró evaluar el parámetro
    function eval( macroVars: TListaDeVariablesPP ): boolean; virtual; abstract;
  end;

  TListaDeParametros = class(TList)
    constructor Create;
    function eval( macroVars: TListaDeVariablesPP ): boolean; virtual;
  end;


  TParametro_str = class( TParametro )
    function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;

  TParametro_NReal = class( TParametro )
    function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;

  TParametro_NInt = class( TParametro )
    function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;


  TParametro_TDAOfStr = class( TParametro )
     function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;

  TParametro_TDAOfNReal = class( TParametro )
     function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;

  TParametro_TDAOfNInt = class( TParametro )
     function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;

  TParametro_TDAOfBool = class( TParametro )
     function eval( macroVars: TListaDeVariablesPP ): boolean; override;
  end;

implementation




function nextPal( var s: string ): string;
begin
  jojo
end;

constructor TParametro.Create( xNombre: string; var xvar; xStr_val: string );
begin
  inherited Create;
  Nombre:= xNombre;
  str_val:= xStr_val;
  pvar:= @xvar;
end;

function TParametro_str.eval( macroVars: TListaDeVariablesPP ): boolean;
var
  ws: wideString;
begin
  ws:= SustituirVariables( str_val, macrovars );
  string( pvar^ ):= ws;
end;

function TParametro_NReal.eval( macroVars: TListaDeVariablesPP ): boolean;
var
  ws: wideString;
begin
  ws:= SustituirVariables( str_val, macrovars );
  try
    NReal( pvar^ ):= StrToFloat( ws );
    result:= true;
  except
    result:= false;
  end;
end;


function TParametro_NInt.eval( macroVars: TListaDeVariablesPP ): boolean;
var
  ws: wideString;
begin
  ws:= SustituirVariables( str_val, macrovars );
  try
    NInt( pvar^ ):= StrToInt( ws );
    result:= true;
  except
    result:= false;
  end;
end;




end.

